
require 'wxruby'

module Ridge
	module Graphics
		class Bitmap < Image
			def initialize(resource, properties, data)
				@filename = properties['file']
				if @filename then
					@bitmap = Wx::Bitmap.new(@filename, Wx::BITMAP_TYPE_ANY)
				else
					@bitmap = nil
				end
			end

			def native()
				@bitmap
			end
		end
		Images['bitmap'] = Bitmap

		class Icon < Image
			def initialize(resource, properties, data)
				@filename = properties['file']
				if @filename then
					@icon = Wx::Icon.new(@filename, Wx::BITMAP_TYPE_ANY)
				else
					@icon = nil
				end
			end

			def native()
				@icon
			end
		end
		Images['icon'] = Icon
	end
end
