

module Ridge
	class YAMLResourceReader < ResourceReader
		def initialize(encoding='utf-8')
			super
			require 'yaml'
			if encoding and Ridge.encoding and encoding!=Ridge.encoding then
				require 'iconv'
				@conv = Iconv.new(Ridge.encoding, encoding)
			else
				@conv = nil
			end
		end

		def parse(stream)
			doc = YAML.load(stream)
			root = parse_element(doc, ResourceElementRoot)
		end

		def parse_element(elem, klass=ResourceElement)
			name = ''
			name = elem.delete('class') if elem.include?('class')
			children = []
      children = elem.delete('children') if elem.include?('children')
			properties = {}
			if @conv then
				elem.each do |aname, val|
          if val.kind_of?(String) then
            properties[@conv.iconv(aname)] = @conv.iconv(val)
          else
            properties[@conv.iconv(aname)] = val
          end
				end
			else
				properties = elem
			end
      children = children.collect { |child|
        parse_element(child)
      }
			return klass.new(name, properties, children, [])
		end
	end
	Resource::Reader['yml'] = YAMLResourceReader
end

